unit Basic_QC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Basic_Form, StdCtrls, TeEngine, Series, StatSeries, TeeProcs, Chart,
  ExtCtrls, MtxVec, Math387, ComCtrls;

type
  TfrmBasicQC = class(TfrmBasic)
    Chart1: TChart;
    Series1: TQCSeries;
    Panel2: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure Recalculate; virtual;
  public
    Data : TMtx;
    DrawVec: TVec;
    DeltaInt : TSample;
    Confidence: TSample;
    { Public declarations }
  end;

var
  frmBasicQC: TfrmBasicQC;

implementation

Uses EditChar, StatQCSeriesEdit, MtxVecEdit;
{$R *.DFM}

procedure TfrmBasicQC.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TfrmBasicQC.Button2Click(Sender: TObject);
begin
  ViewValues(Data,Data.Caption,True,False);
  Recalculate;
end;

procedure TfrmBasicQC.FormCreate(Sender: TObject);
begin
  inherited;
  Data := TMtx.Create;
  DrawVec := TVec.Create;
  Edit1.Text := FormatFloat('0.00',99.8);
  Confidence := 99.8;
end;

procedure TfrmBasicQC.FormDestroy(Sender: TObject);
begin
  Data.Destroy;
  DrawVec.Destroy;
  inherited;
end;

procedure TfrmBasicQC.Recalculate;
begin
  { virtual }
end;

procedure TfrmBasicQC.Edit1Change(Sender: TObject);
begin
  if (Showing) and (Edit1.Text <> '') then
  begin
    try
      Confidence := StrToFloat(Edit1.Text);
    except
      Confidence := 99.8;
    end;
    Recalculate;
  end;
end;

end.
