unit Basic_Wizard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmBasicWizard = class(TForm)
    Panel1: TPanel;
    btnHelp: TButton;
    btnBack: TButton;
    btnNext: TButton;
    btnCancel: TButton;
    Panel2: TPanel;
    lblHeader: TLabel;
    PageControl: TPageControl;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
  private
    { Private declarations }
    DefTabWidth : Integer;
    FFormatString: string;
    procedure SetFormatString(const Value: string);
  protected
    procedure RefreshButtons; virtual;
  public
    { Public declarations }
    procedure SetupTabs(Const NumTabs: Integer; RichEdit: TRichEdit);
    property FormatString: string read FFormatString write SetFormatString;
  end;

var
  frmBasicWizard: TfrmBasicWizard;

implementation

Uses Math387;

{$R *.DFM}

procedure TfrmBasicWizard.btnCancelClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmBasicWizard.RefreshButtons;
begin
  BtnBack.Enabled := PageControl.ActivePage.PageIndex > 0;
end;

procedure TfrmBasicWizard.SetupTabs(const NumTabs: Integer;
  RichEdit: TRichEdit);
var i : Integer;
begin
  RichEdit.Paragraph.Tab[0] := 0;
  for i := 1 to RichEdit.Paragraph.TabCount - 1 do
    RichEdit.Paragraph.Tab[i] := RichEdit.Paragraph.Tab[i-1]+DefTabWidth;
end;

procedure TfrmBasicWizard.FormShow(Sender: TObject);
begin
  { improve this }
  DefTabWidth := Max(70,Canvas.TextWidth('+'+FormatString)+10);
end;

procedure TfrmBasicWizard.SetFormatString(const Value: string);
begin
  FFormatString := Value;
end;

procedure TfrmBasicWizard.FormCreate(Sender: TObject);
begin
  FFormatString := '0.0000';
end;

procedure TfrmBasicWizard.btnNextClick(Sender: TObject);
begin
  // Next button event comes here
end;

procedure TfrmBasicWizard.btnBackClick(Sender: TObject);
begin
  // Previous button event comes here
end;

end.
