{*******************************************}
{   Delphi Lab Tools 1.0                    }
{                                           }
{   Statistics  ToolBox                     }
{   StatAxisLabelTool editor                }
{                                           }
{   By Marjan Slatinek                      }
{   Copyright (c) 1999-2001 Dew Research    }
{   All Rights Reserved                     }
{*******************************************}
{:TStatAxisLabelTool editor.}
unit StatAxisLabelToolEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Chart, TeEngine, TeeProcs, StatAxisLabelTool;

type
  {:@exclude}
  TStatAxisEditor = class(TForm)
    RGType: TRadioGroup;
    CBVertAxes: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure RGTypeClick(Sender: TObject);
    procedure CBVertAxesChange(Sender: TObject);
  private
    Tool: TStatAxisLabelTool;
    procedure AddVertAxes(AChart:TCustomAxisPanel; AList:TStrings);
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

Uses TeeConst;
{$R *.DFM}

{ TStatAxisToolEdit }

procedure TStatAxisEditor.AddVertAxes(AChart: TCustomAxisPanel;
  AList: TStrings);
var t : Integer;
begin
  With AList do
  begin
    Clear;
    Add(TeeMsg_LeftAxis);
    Add(TeeMsg_RightAxis);
    for t:=5 to AChart.Axes.Count-1 do
      if Not(AChart.Axes[t].Horizontal) then Add(TeeMsg_CustomAxesEditor+IntToStr(t-5));
  end;
end;

procedure TStatAxisEditor.FormShow(Sender: TObject);
begin
  Tool := TStatAxisLabelTool(Tag);
  AddVertAxes(Tool.ParentChart,CBVertAxes.Items);
  With Tool do
    With ParentChart,CBVertAxes do
    if Axis=LeftAxis then ItemIndex:=0 else
    if Axis=RightAxis then ItemIndex:=1
    else ItemIndex:=Axes.IndexOf(Axis)-3;

  Case Tool.ProbSeriesType of
    stNormalSeries : RGType.ItemIndex:=0;
    stWeibullSeries : RGType.ItemIndex:=1;
    stQQSeries : RGType.ItemIndex:=2;
  end;
end;

procedure TStatAxisEditor.RGTypeClick(Sender: TObject);
begin
  With Tool do
  Case RGType.ItemIndex of
    0: ProbSeriesType := stNormalSeries;
    1: ProbSeriesType := stWeibullSeries;
    2: ProbSeriesType := stQQSeries;
  end;
end;

procedure TStatAxisEditor.CBVertAxesChange(Sender: TObject);
begin
  With Tool do
  Case CBVertAxes.ItemIndex of
    -1: Axis:=nil;
     0: Axis:=ParentChart.LeftAxis;
     1: Axis:=ParentChart.RightAxis;
  else
    Axis:=ParentChart.Axes[CBVertAxes.ItemIndex+3];
  end;
end;

initialization
  RegisterClass(TStatAxisEditor);

end.
